from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, File, Int

Gsutil_Config_V0_1_0 = CommandToolBuilder(tool="gsutil_config", base_command=["gsutil", "config"], inputs=[ToolInput(tag="in_see_options_cause", input_type=String(optional=True), prefix="-f", doc=InputDocumentation(doc="(see OPTIONS below) cause gsutil config to request a token")), ToolInput(tag="in_prompt_google_cloud", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="Prompt for Google Cloud Storage access key and secret (the older\nauthentication method before OAuth2 was supported) instead of\nobtaining an OAuth2 token.")), ToolInput(tag="in_causes_gsutil_config", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="Causes gsutil config to launch a browser to obtain OAuth2 approval\nand the project ID instead of showing the URL for each and asking\nthe user to open the browser. This will probably not work as\nexpected if you are running gsutil from an ssh window, or using\ngsutil on Windows.")), ToolInput(tag="in_prompt_service_account", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="Prompt for service account credentials. This option requires that")), ToolInput(tag="in_write_configuration_file_authentication", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="Write the configuration file without authentication configured.\nThis flag is mutually exlusive with all flags other than -o.")), ToolInput(tag="in_write_configuration_file_instead", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Write the configuration to <file> instead of ~/.boto.\nUse '-' for stdout.")), ToolInput(tag="in_request_token_restricted_readonly", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="Request token restricted to read-only access.")), ToolInput(tag="in_request_additional_scope", input_type=Int(optional=True), prefix="-s", doc=InputDocumentation(doc="Request additional OAuth2 <scope>.")), ToolInput(tag="in_request_token_restricted_readwrite", input_type=Boolean(optional=True), prefix="-w", doc=InputDocumentation(doc="Request token restricted to read-write access.")), ToolInput(tag="in_scopes_dot", input_type=String(), position=0, doc=InputDocumentation(doc="If you want to use credentials based on access key and secret (the older")), ToolInput(tag="in_aws_access_key_id", input_type=String(), position=0, doc=InputDocumentation(doc="aws_secret_access_key")), ToolInput(tag="in_gs_access_key_id", input_type=String(), position=1, doc=InputDocumentation(doc="gs_host")), ToolInput(tag="in_gs_json_host", input_type=String(), position=2, doc=InputDocumentation(doc="gs_json_port")), ToolInput(tag="in_gs_o_auth_two_refresh_token", input_type=Int(), position=3, doc=InputDocumentation(doc="gs_port")), ToolInput(tag="in_gs_secret_access_key", input_type=String(), position=4, doc=InputDocumentation(doc="s3_host")), ToolInput(tag="in_proxy", input_type=String(), position=5, doc=InputDocumentation(doc="proxy_port")), ToolInput(tag="in_proxy_user", input_type=String(), position=6, doc=InputDocumentation(doc="proxy_pass")), ToolInput(tag="in_https_validate_certificates", input_type=String(), position=7, doc=InputDocumentation(doc="debug")), ToolInput(tag="in_max_retry_delay", input_type=String(), position=8, doc=InputDocumentation(doc="num_retries")), ToolInput(tag="in_service_account", input_type=String(), position=0, doc=InputDocumentation(doc="[GSUtil]")), ToolInput(tag="in_check_hashes", input_type=String(), position=1, doc=InputDocumentation(doc="content_language")), ToolInput(tag="in_default_api_version", input_type=String(), position=0, doc=InputDocumentation(doc="default_project_id")), ToolInput(tag="in_json_api_version", input_type=String(), position=1, doc=InputDocumentation(doc="parallel_composite_upload_component_size")), ToolInput(tag="in_parallel_composite_upload_threshold", input_type=String(), position=2, doc=InputDocumentation(doc="sliced_object_download_component_size")), ToolInput(tag="in_sliced_object_download_max_components", input_type=String(), position=3, doc=InputDocumentation(doc="sliced_object_download_threshold")), ToolInput(tag="in_parallel_process_count", input_type=String(), position=4, doc=InputDocumentation(doc="parallel_thread_count")), ToolInput(tag="in_prefer_api", input_type=String(), position=5, doc=InputDocumentation(doc="resumable_threshold")), ToolInput(tag="in_state_dir", input_type=String(), position=0, doc=InputDocumentation(doc="tab_completion_time_logs")), ToolInput(tag="in_tab_completion_timeout", input_type=String(), position=1, doc=InputDocumentation(doc="task_estimation_threshold")), ToolInput(tag="in_client_id", input_type=String(), position=2, doc=InputDocumentation(doc="client_secret")), ToolInput(tag="in_o_auth_two_refresh_retries", input_type=Int(), position=3, doc=InputDocumentation(doc="provider_authorization_uri")), ToolInput(tag="in_provider_label", input_type=String(), position=4, doc=InputDocumentation(doc="provider_token_uri")), ToolInput(tag="in_token_cache", input_type=String(), position=5, doc=InputDocumentation(doc="UPDATING TO THE LATEST CONFIGURATION FILE"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gsutil_Config_V0_1_0().translate("wdl", allow_empty_container=True)

